import GameLogic
import math
import mathutils

# init
accX = 0
accY = 0
accZ = 0

#############################################################################
#set objects orientation
def owner_orientation(alpha, beta, gamma):
	alpha = alpha * 3.1416 / 180
	beta = beta * 3.1416 / 180
	gamma = gamma * 3.1416 / 180
	rot_en_euler = mathutils.Euler([alpha, beta, gamma])
	owner.worldOrientation = rot_en_euler.to_matrix()
#############################################################################

# Get owner, host, port
controller = GameLogic.getCurrentController()
owner = controller.owner

#############################################################################
# Example of wii
# ['#bundle', 0.0, ['/roll', ',f', 1.5], ['/pitch', ',i', 0], ['/a', ',i', 0], ['/b', ',i', 0], ['/accX', ',f', -0.92], ['/accY', ',i', 0], ['/accZ', ',f', 0.03]]
#############################################################################

## Get all data from wii and set all prop in owner
wii = GameLogic.wii

# How many data
nbVal = len(wii)

# Set prop with good data
for i in range(nbVal - 2):
	if wii[i + 2][0] == '/roll' :
		roll = GameLogic.wii[i + 2][2]

	if wii[i + 2][0] == '/pitch' :
		pitch = GameLogic.wii[i + 2][2]

	if wii[i + 2][0] == '/a' :
		a = GameLogic.wii[i + 2][2]
		if a == 8:
			owner['a'] = True
		else:
			owner['a'] = False

	if wii[i + 2][0] == '/b' :
		b = GameLogic.wii[i + 2][2]
		if b == 4:
			owner['b'] = True
		else:
			owner['b'] = False

	if wii[i + 2][0] == '/plus' :
		plus = GameLogic.wii[i + 2][2]
		if plus == 16:
			owner['plus'] = True
		else:
			owner['plus'] = False

	if wii[i + 2][0] == '/minus' :
		minus = GameLogic.wii[i + 2][2]
		if minus == 16:
			owner['minus'] = True
		else:
			owner['minus'] = False

	if wii[i + 2][0] == '/home' :
		home = GameLogic.wii[i + 2][2]
		if home == 128:
			owner['home'] = True
		else:
			owner['home'] = False

	if wii[i + 2][0] == '/1' :
		one = GameLogic.wii[i + 2][2]
		if one == 2:
			owner['1'] = True
		else:
			owner['1'] = False

	if wii[i + 2][0] == '/2' :
		two = GameLogic.wii[i + 2][2]
		if two == 1:
			owner['2'] = True
		else:
			owner['2'] = False

	if wii[i + 2][0] == '/up' :
		up = GameLogic.wii[i + 2][2]
		if up == 8:
			owner['up'] = True
		else:
			owner['up'] = False

	if wii[i + 2][0] == '/down' :
		down = GameLogic.wii[i + 2][2]
		if down == 4:
			owner['down'] = True
		else:
			owner['down'] = False

	if wii[i + 2][0] == '/right' :
		right = GameLogic.wii[i + 2][2]
		if right == 2:
			owner['right'] = True
		else:
			owner['right'] = False

	if wii[i + 2][0] == '/left' :
		left = GameLogic.wii[i + 2][2]
		if left == 1:
			owner['left'] = True
		else:
			owner['left'] = False

	if wii[i + 2][0] == '/accX' :
		owner['accX'] = GameLogic.wii[i + 2][2]

	if wii[i + 2][0] == '/accY' :
		owner['accY'] = GameLogic.wii[i + 2][2]

	if wii[i + 2][0] == '/accZ' :
		owner['accZ'] = GameLogic.wii[i + 2][2]

# Motion plus
	if wii[i + 2][0] == '/mp-pitch' :
		owner['mp-pitch'] = GameLogic.wii[i + 2][2]

	if wii[i + 2][0] == '/mp-roll' :
		owner['mp-roll'] = GameLogic.wii[i + 2][2]
	
	if wii[i + 2][0] == '/mp-yaw' :
		owner['mp-yaw'] = GameLogic.wii[i + 2][2]

# Nunchuck


#############################################################################
## Use the datas
# Set realistic angle
alpha = pitch * 10.0
beta = 0
gamma = roll * 10.0 + 90

# Set x y z
accX = accX / 5.0 + 0.1
accY = accY / 5.0 - 0.6
accZ = accZ / 5.0 + 0.4


#apply to objects world orientation if socket connected
owner_orientation(alpha, beta, gamma)
owner.worldPosition = (accX, accY, accZ)

#############################################################################




